using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Xml;
using Microsoft.SmallBasic.Library;

namespace BloggerReader
{
    /// <summary>
    /// Leitor de Blog
    /// </summary>
    [SmallBasicType]
    public static class BloggerReader
    {

        private static Primitive urlRss = "";

        /// <summary>
        /// Endereo do Blog
        /// </summary>
        public static Primitive UrlDoBlog
        {
            get { return BloggerReader.urlRss; }
            set { BloggerReader.urlRss = value + @"/feeds/posts/default"; }
        }

        /// <summary>
        /// Le o titulo da postagem
        /// </summary>
        /// <param name="Index">Numero da Postagem</param>
        /// <returns>Titulo</returns>
        public static Primitive LerTitulo(Primitive Index)
        {
            Primitive resultado;
            try
            {
                resultado = LerRSS("title",Index);

            }
            catch
            {
                resultado = "Sem Novidades";
            }
            return resultado;
        }

        /// <summary>
        /// Le o Conteudo da postagem
        /// </summary>
        /// <param name="Index">Numero da Postagem</param>
        /// <returns>Conteudo em HTML</returns>
        public static Primitive LerConteudo(Primitive Index)
        {
            Primitive resultado;
            try
            {
                resultado = LerRSS("content", Index);
            }
            catch
            {
                resultado = "Sem Novidades";
            }
            return resultado;
        }

        private static Primitive LerRSS(string Elemento, Primitive Index)
        {
            XmlDocument xmldoc = new XmlDocument();
            xmldoc.LoadXml(Network.GetWebPageContents(urlRss));

            XmlNode elemList = xmldoc.GetElementsByTagName(@"entry")[Index];

            
            Primitive result;

            result = "";

            foreach (XmlNode title in elemList)
            {
                if (title.Name == Elemento)
                {
                    result = (title.InnerXml);
                    break;
                }
            }
            return result;
        }

    }
}
